import xml
import urllib.request, urllib.parse, urllib.error
from xml.dom import minidom

@plugin
class Wikipedia(object):
    def __init__(self, server):
        self.server = server
        self.commands = ["wp"]
        self.server.handle("command", self.handle_command, self.commands)
    
    def handle_command(self, channel, user, cmd, args):
        if cmd == "wp":
            if len(args) < 1: 
                self.server.doMessage(channel, user+": Not enough arguments.")
                return
            
            url = "http://en.wikipedia.org/w/api.php?action=opensearch&limit=3&namespace=0&format=xml&search="
            query = " ".join(args)
            search = url + urllib.parse.quote_plus(query, "/")
            
            try:
                data = urllib.request.urlopen(search).readlines()
            except IOError as ioe:
                self.server.doMessage(channel, user+": I/O Error retrieving the results: "+ioe)
                return
            
            try:
                xmldoc = minidom.parseString(data[0]) 
            except xml.parsers.expat.ExpatError as e:
                self.server.doMessage(channel, user+": Error parsing the xml search results. Error code "+str(e.code)+". Line number: "+str(e.lineno)+". Offset "+str(e.offset) )
                return
            
            searchResults = xmldoc.childNodes[0].childNodes[1].childNodes
            for result in searchResults:
                #print str(result)
                resultStr = ""
                for item in result.childNodes:
                    for textNode in item.childNodes:
                        resultStr += textNode.data + " - "
                print(resultStr)
                #self.server.doMessage(channel, user+": Hi.")
                self.server.doMessage(channel, user+": "+resultStr)
